/**
 * OSDN REST API v0 beta
 * OSDN REST API. Currently this API is experimental release. Pelase refer documentation on https://osdn.net/projects/osdn-codes/wiki/APIGuide and you can get client libraries from https://osdn.net/projects/osdn-codes/releases/p14859 . 
 *
 * OpenAPI spec version: 0.0.20171120
 * Contact: admin@osdn.net
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['OSDN/ApiClient', 'OSDN/OSDN\Model/ProjectSCMLastCommit'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ProjectSCMLastCommit'));
  } else {
    // Browser globals (root is window)
    if (!root.OSDNClient) {
      root.OSDNClient = {};
    }
    root.OSDNClient.ProjectSCM = factory(root.OSDNClient.ApiClient, root.OSDNClient.ProjectSCMLastCommit);
  }
}(this, function(ApiClient, ProjectSCMLastCommit) {
  'use strict';




  /**
   * The ProjectSCM model module.
   * @module OSDN/OSDN\Model/ProjectSCM
   * @version 0.0.20161031
   */

  /**
   * Constructs a new <code>ProjectSCM</code>.
   * @alias module:OSDN/OSDN\Model/ProjectSCM
   * @class
   */
  var exports = function() {
    var _this = this;
















  };

  /**
   * Constructs a <code>ProjectSCM</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:OSDN/OSDN\Model/ProjectSCM} obj Optional instance to populate.
   * @return {module:OSDN/OSDN\Model/ProjectSCM} The populated <code>ProjectSCM</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'Integer');
      }
      if (data.hasOwnProperty('created')) {
        obj['created'] = ApiClient.convertToType(data['created'], 'Boolean');
      }
      if (data.hasOwnProperty('active')) {
        obj['active'] = ApiClient.convertToType(data['active'], 'Boolean');
      }
      if (data.hasOwnProperty('setting_applied')) {
        obj['setting_applied'] = ApiClient.convertToType(data['setting_applied'], 'Boolean');
      }
      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('mail_enabled')) {
        obj['mail_enabled'] = ApiClient.convertToType(data['mail_enabled'], 'Boolean');
      }
      if (data.hasOwnProperty('mail_recipients')) {
        obj['mail_recipients'] = ApiClient.convertToType(data['mail_recipients'], 'String');
      }
      if (data.hasOwnProperty('url_viewer')) {
        obj['url_viewer'] = ApiClient.convertToType(data['url_viewer'], 'String');
      }
      if (data.hasOwnProperty('url_rw')) {
        obj['url_rw'] = ApiClient.convertToType(data['url_rw'], 'String');
      }
      if (data.hasOwnProperty('url_ro')) {
        obj['url_ro'] = ApiClient.convertToType(data['url_ro'], 'String');
      }
      if (data.hasOwnProperty('last_commit')) {
        obj['last_commit'] = ProjectSCMLastCommit.constructFromObject(data['last_commit']);
      }
      if (data.hasOwnProperty('branches')) {
        obj['branches'] = ApiClient.convertToType(data['branches'], ['String']);
      }
      if (data.hasOwnProperty('tags')) {
        obj['tags'] = ApiClient.convertToType(data['tags'], ['String']);
      }
    }
    return obj;
  }

  /**
   * @member {Integer} id
   */
  exports.prototype['id'] = undefined;
  /**
   * @member {Boolean} created
   */
  exports.prototype['created'] = undefined;
  /**
   * @member {Boolean} active
   */
  exports.prototype['active'] = undefined;
  /**
   * @member {Boolean} setting_applied
   */
  exports.prototype['setting_applied'] = undefined;
  /**
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * @member {String} type
   */
  exports.prototype['type'] = undefined;
  /**
   * @member {Boolean} mail_enabled
   */
  exports.prototype['mail_enabled'] = undefined;
  /**
   * @member {String} mail_recipients
   */
  exports.prototype['mail_recipients'] = undefined;
  /**
   * @member {String} url_viewer
   */
  exports.prototype['url_viewer'] = undefined;
  /**
   * @member {String} url_rw
   */
  exports.prototype['url_rw'] = undefined;
  /**
   * @member {String} url_ro
   */
  exports.prototype['url_ro'] = undefined;
  /**
   * @member {module:OSDN/OSDN\Model/ProjectSCMLastCommit} last_commit
   */
  exports.prototype['last_commit'] = undefined;
  /**
   * @member {Array.<String>} branches
   */
  exports.prototype['branches'] = undefined;
  /**
   * @member {Array.<String>} tags
   */
  exports.prototype['tags'] = undefined;



  return exports;
}));


